#include "bits/stdc++.h"

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()
struct mem {
    int x, type, y1, y2;
};

const int R = 1LL<<17;

struct SegmentTree {
    struct node {
        int l, r;
        int sum, here;

        node() {};

        node(int l, int r, int sum, int here) : l(l), r(r), sum(sum), here(here) {};
    };

    vector<node> cont;
    int root = 0;

    SegmentTree() { cont.emplace_back(-1, -1, 0, 0); };

    int f(int x) {
        if (x == -1) {
            x = sz(cont);
            cont.emplace_back(-1, -1, 0, 0);
        }
        return x;
    }

    void upd(int x, int xl, int xr, int ql, int qr, int d) {
        if (qr <= xl || xr <= ql)
            return;
        if (xl + 1 < xr) {
            cont[x].l = f(cont[x].l);
            cont[x].r = f(cont[x].r);
        }
        if (ql <= xl && xr <= qr) {
            if (d == 0)
                cont[x].here++;
            else
                cont[x].here--;
            if (cont[x].here)
                cont[x].sum = xr - xl;
            else {
                if (cont[x].l != -1)
                    cont[x].sum = cont[cont[x].l].sum + cont[cont[x].r].sum;
            }
            return;
        }
        int mid = (xl + xr) >> 1;
        upd(cont[x].l, xl, mid, ql, qr, d);
        upd(cont[x].r, mid, xr, ql, qr, d);
        if (cont[x].here)
            cont[x].sum = xr - xl;
        else {
            if (cont[x].l != -1)
                cont[x].sum = cont[cont[x].l].sum + cont[cont[x].r].sum;
        }
    }

};

void solve() {
    int k, n;
    cin >> k >> n;
    int x = 0;
    int y = 0;
    vector<mem> t;
    for (int l = 0; l < n; ++l) {
        char e;
        int a;
        cin >> e >> a;
        if (e == 'N') {
            t.push_back({x, 0, y, y + k + a});
            t.push_back({x + k, 1, y, y + k + a});
            y += a;
        }
        if (e == 'S') {
            t.push_back({x, 0, y-a, y + k });
            t.push_back({x + k, 1, y-a, y + k});
            y -= a;
        }
        if (e == 'W') {
            t.push_back({x - a, 0, y, y + k});
            t.push_back({x + k, 1, y, y + k});
            x -= a;
        }
        if (e == 'E') {
            t.push_back({x, 0, y, y + k});
            t.push_back({x + k + a, 1, y, y + k});
            x += a;
        }
    }
    sort(all(t), [&](mem a, mem b) {
        if (a.x != b.x)
            return a.x < b.x;
        if (a.type != b.type)
            return a.type < b.type;
        return make_pair(a.y1, a.y2) < make_pair(b.y1, b.y2);
    });
    int ans = 0;
    int last = t.begin()->x;
    SegmentTree sg;
    for (auto [X, type, y1, y2]: t) {
        ans += (X - last) * sg.cont[sg.root].sum;
        last = X;
        sg.upd(sg.root, -R, R, y1, y2, type);
    }
    cout << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
//    cin >> _;
    while (_--)
        solve();
    return 0;
}
